(document:surround "/std/frame")
(document:insert "/std/functions")

(document:envelop with-translation _ "alterator-users")

(document:envelop with-proxy-attributes
                  ((password1 ((proxy-get self)
                               (if (passwd-mode state)
                                   (auto-passwd text)
                                   (p1 text)))
                              ((proxy-set self value)
                               (auto-passwd text value)
                               (p1 text value)))

                   (password2 ((proxy-get self)
                               (if (passwd-mode state)
                                   (auto-passwd text)
                                   (p2 text)))
                              ((proxy-set self value)
                               (auto-passwd text value)
                               (p2 text value)))
                   (password-changed ((proxy-set self value)
                                      (p1 changed)
                                      (p2 changed)
                                      (auto-passwd changed)))))

(define (generate)
  (woo-catch/message
   (thunk
    (auto-passwd text
                 (woo-get-option
                  (woo-read-first "/pwgen")
                  'password))
    (auto-passwd changed))))

(define (change-mode)
  (let ((v-state (not (passwd-mode state))))
    (manual-box visibility v-state)
    (auto-box visibility (not v-state))
    (auto-passwd changed)
    (if (auto-box visibility) (generate))))

(define (small x)
  (string-append "<small>" x "</small>"))

(define (manual-mode)
  (document:id manual-box
               (gridbox
                columns "60;40"
                (document:id p1 (edit "" widget-name "passwd1" echo "stars"))
                (document:id p1-label (label (small (_ "(enter passphrase)"))))
                (document:id p2 (edit "" widget-name "passwd2" echo "stars"))
                (document:id p2-label (label (small (_ "(repeat passphrase)")))))))
  
(define (auto-mode)
  (document:id auto-box
               (gridbox columns "60;40"
                        invisible
                        ;;(edit "" widget-name "passwd1" invisible)
                        (document:id auto-passwd (edit "" widget-name "passwd1"))
                        (document:id gen-passwd (button (_ "Generate") (when clicked (generate)))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(document:id passwd-mode
             (checkbox (_ "Generate automatically")
                       state #f
                       (when toggled (change-mode))))
;;(radio (_ "Generate automatically"))
(manual-mode)
(auto-mode)
